#ifndef __UTIL__
#define __UTIL__

#include <math.h>     // log, ceil
#include <float.h>    // MAX_FLT
#include <algorithm> 

namespace SD {

typedef unsigned int  uint;
typedef unsigned char uchar;
typedef float         Real;
typedef uint          Label;

#define _STR_(x)  #x
#define _STR(x)   _STR_(x)
#define HERE      __FILE__ " (" _STR(__LINE__) "): "

// Maximum input length
const unsigned int BUFF_SIZE  = 1024*128;
const unsigned int MAX_LENGTH = 1024;
const Real         MIN_REAL   = -1*FLT_MAX;
const Real         ZERO       = 0.0f;
const char         SEP        = ' ';


// 2n
inline uint pow2( uint n ) {

    uint r = 1;
    for ( uint i = 0; i < n; ++i ) {
	r *= 2;
    }
    return r;
}


inline uint degenerate_label_num( uint L ) {
    
    uint D = 0;
    uint i = 1;
    while ( i < L ) {
	++D;
	i *= 2;
    }
    return D;
}

//  ΡɤΥ׻
//  v[0]..v[L-1] ˥ꥸʥΡɤΥǼƤ롥
//  v[L]..v[L+D-1] ˽ΡɤΥ׻
inline void estimate_ub( Real* v, uint L, uint D, uint active_label_num ) {
    
    Real* it = std::max_element( v + active_label_num, v + L );
    v[L+D-1] = *it;
    
    for ( uint z = L+D-2; L <= z; --z ) {
	active_label_num /= 2;
	it = std::max_element( v + active_label_num, v + 2*active_label_num );
	if ( *it < v[z+1] ) {
	    v[z] = v[z+1];
	}else {
	    v[z] = *it;
	}
    }
}

inline void estimate_ub( Real* v, uint L, uint D ) {

    estimate_ub( v, L, D, pow2(D-1) );
}

}

#endif
